package com.persagy.dmp.admin.config.web;

import com.persagy.dmp.admin.config.shiro.UserModel;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.subject.Subject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Component
public class UserUtils extends HandlerInterceptorAdapter {

    private static final ThreadLocal<Integer> THREAD_LOCAL_USER = new ThreadLocal<Integer>();

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        Subject currentUser = SecurityUtils.getSubject();
        if (currentUser.isAuthenticated()) {
            UserModel userModel = (UserModel) currentUser.getPrincipal();
            THREAD_LOCAL_USER.set(userModel.getId());
        }
        return true;
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        clear();
    }

    public static Integer currentUserId() {
        return THREAD_LOCAL_USER.get();
    }

    public static final void clear() {
        THREAD_LOCAL_USER.remove();
    }

}
