package com.persagy.dmp.rwd.edit.controller;

import com.persagy.common.criteria.JacksonCriteria;
import com.persagy.common.web.MapResponse;
import com.persagy.common.web.PagedResponse;
import com.persagy.dmp.rwd.edit.entity.FuncidDefChangeRecord;
import com.persagy.dmp.rwd.edit.service.FuncidDefChangeRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/rwdedit/funcidDef/changeRecord")
public class FuncidDefChangeRecordController {

    @Autowired
    private FuncidDefChangeRecordService service;

    @PostMapping("/query")
    public PagedResponse<FuncidDefChangeRecord> query(@RequestBody JacksonCriteria criteria) {
        return service.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody FuncidDefChangeRecord param) {
        return service.create(param);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody FuncidDefChangeRecord param) {
        return service.update(param);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody FuncidDefChangeRecord param) {
        return service.delete(param);
    }

    @PostMapping("/addVersion")
    public MapResponse addVersion(@RequestParam String version, @RequestBody List<Integer> idList) {
        return service.addVersion(version, idList);
    }
}
